#include "ImageWidget.h"
#include "TargaImage.h"
#include <Fl/Fl_Window.h>
#include <Fl/fl_draw.h>
#include <libtarga.h>

ImageWidget::ImageWidget(int x, int y, int w, int h, char *title)
    :Fl_Widget(x, y, w, h, title)
{
    image = NULL;
}


void
ImageWidget::Set_Image(TargaImage *i)
{
    Fl_Widget	*p = parent();

    image = i;

    // Resize the parent, which resizes this window, and force a redraw.
    p->size(image->width * 2 + 15, image->height + 35);

    p->redraw();
}


TargaImage*
ImageWidget::Get_Image(void)
{
    return image;
}


void
ImageWidget::draw(void)
{
    unsigned char   *rgb;
    TargaImage	    *alpha_image;

    if ( ! image )
	// Don't do anything if the image is empty.
	return;

    rgb = image->To_RGB(); // Convert the pre-multiplied RGBA image into RGB.
    fl_draw_image(rgb, x(), y(), image->width, image->height, 3);
    delete[] rgb;

    alpha_image = image->Alpha_Image();
    rgb = alpha_image->To_RGB();
    fl_draw_image(rgb, x() + image->width + 5, y(), image->width, image->height, 3);
    delete[] rgb;
}


void
ImageWidget::Redraw_Image(void)
{
    redraw();
}

